﻿;
(function () {
     var wx_safetree_match = {
		preVerifyJSAPI: "config",
		config: "config",
		onmenusharewx: "onmenusharewx",
		sendAppMessage: "sharewx",
        sharewx: "sharewx",
		onmenusharewxzone: "onmenusharewxzone",
		shareTimeline: "sharewxzone",
        sharewxzone: "sharewxzone",
		onmenushareqq: "onmenushareqq",
		shareQQ: "shareqq",
		shareqq: "shareqq",
		onmenushareqqzone: "onmenushareqqzone",
		shareQZone: "shareqqzone",
		shareqqzone: "shareqqzone"
	};
	wx_safetree_match["menu:share:timeline"]="onmenusharewxzone";
	wx_safetree_match["menu:share:appmessage"]="onmenusharewx";
	wx_safetree_match["menu:share:qq"]= "onmenushareqq";
	wx_safetree_match["menu:share:QZone"]= "onmenushareqqzone";
    function matchInterface(a) {
        if (typeof a == "string") {
            return wx_safetree_match[a] || a;
        }
        if (typeof a == "object" && a.verifyJsApiList) {
            for (var i = 0; i < a.verifyJsApiList.length; i++) {
                a.verifyJsApiList[i] = matchInterface(a.verifyJsApiList[i]);
            }
            return a;
        }
	return a;
    }
    var messagingIframe;
    var sendMessageQueue = [];
    var sendSettingQueue = [];
    var messageHandlers = {};
    var _event_hook_map = {};
    var CUSTOM_PROTOCOL_SCHEME = 'safeapp';
    var QUEUE_HAS_MESSAGE = '__QUEUE_MESSAGE__/';
    var responseCallbacks = {};
    var uniqueId = 1;
    function _createQueueReadyIframe(doc) {
        messagingIframe = doc.createElement('iframe');
        messagingIframe.style.display = 'none';
        doc.documentElement.appendChild(messagingIframe);
    }
    function isAndroid() {
        var ua = navigator.userAgent.toLowerCase();
        var isA = ua.indexOf("android") > -1;
        if (isA) {
            return true;
        }
        return false;
    }
    function send(data, responseCallback) {
        _doSend({
            data: data
        }, responseCallback);
    }

    function registerHandler(handlerName, handler) {
        messageHandlers[handlerName] = handler;
    }

    function callHandler(handlerName, data, responseCallback) {
        handlerName = matchInterface(handlerName);
        data = matchInterface(data);
        if (handlerName != "") {
            _doSend({
                handlerName: handlerName,
                data: data
            }, responseCallback);
        }
    }

    function _doSend(message, responseCallback) {
        if (typeof responseCallback === 'function') {
            var callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = responseCallback;
            message.callbackId = callbackId;
        }
        sendMessageQueue.push(message);
        messagingIframe.src = CUSTOM_PROTOCOL_SCHEME + '://' + QUEUE_HAS_MESSAGE;
    }

    function on(event, callback) {
        if (!event || typeof event !== 'string') {
            return;
        }
        if (typeof callback !== 'function') {
            return;
        }
        event = matchInterface(event);
        if (event != "") {
            _event_hook_map[event] || (_event_hook_map[event] = callback);

            callHandler("btnsetting", event, callback);
        }
    }
    function _call(func, params, callback) {
        if (!func || typeof func !== 'string') {
            return;
        };
        if (typeof params !== 'object') {
            params = {};
        };
        callHandler(func, params, callback);
    }
    function _env(key) {
        return '';
    }

    function _log(fmt) {
        console.log(JSON.stringify(fmt));
    }
    function _continueSetResult() {
        console.log('不支持微信此接口');
    }
    function _fetchQueue() {
        var messageQueueString = JSON.stringify(sendMessageQueue);
        sendMessageQueue = [];
        if (isAndroid()) {
			messagingIframe.src = CUSTOM_PROTOCOL_SCHEME + '://return/_fetchQueue/' + encodeURIComponent(messageQueueString);
        } else {
            return messageQueueString;
        }
    }
    function _handleMessageFromNative(messageJSON) {
        _dispatchMessageFromNative(messageJSON);
    }

    function _dispatchMessageFromNative(messageJSON) {
        setTimeout(function () {
            var message = JSON.parse(messageJSON);
            var responseCallback;
            if (message.responseId) {
                responseCallback = responseCallbacks[message.responseId];
                if (!responseCallback) {
                    return;
                }
                responseCallback(message.responseData);
            } else {
                if (message.callbackId) {
                    var callbackResponseId = message.callbackId;
                    responseCallback = function (responseData) {
                        _doSend({
                            responseId: callbackResponseId,
                            responseData: responseData
                        });
                    };
                }

                var handler;
                if (message.handlerName) {
                    handler = messageHandlers[message.handlerName];
                }
                if (!!handler) {
                    try {
                        handler(message.data, responseCallback);
                    } catch (exception) {
                        if (typeof console != 'undefined') {
                            console.log("safeJSBridge: WARNING: javascript handler threw.", message, exception);
                        }
                    }
                } else {
                    handler = _event_hook_map[message.handlerName];
                    if (!handler) {
                        return;
                    }
                    handler();
                }
            }
        });
    }
    safeJSBridge = window.WeixinJSBridge = window.safeJSBridge = {
        on: on,
        invoke: _call,
        call: _call,
        env: _env,
        log: _log,
        _fetchQueue: _fetchQueue,
        _handleMessageFromNative: _handleMessageFromNative,
        _handleMessageFromWeixin: _handleMessageFromNative,
        _hasInit: false,
        _hasPreInit: false,
        _continueSetResult: _continueSetResult
    };

    var doc = document;
    _createQueueReadyIframe(doc);
    var readyEvent = doc.createEvent('HTMLEvents');
    readyEvent.initEvent('safeJSBridgeReady', true, true);
    readyEvent.bridge = safeJSBridge;
    doc.dispatchEvent(readyEvent);
    readyEvent = doc.createEvent('HTMLEvents');
	readyEvent.initEvent('WeixinJSBridgeReady');
    readyEvent.bridge = safeJSBridge;
	doc.dispatchEvent(readyEvent);
})();